//
// Created by 阳坤 on 2022/3/1.
//

#include "video_similarity.h"


long video_similarity_detection_init(const char *url) {
    auto *ctx = (VideoSimilarityContext *) malloc(sizeof(VideoSimilarityContext));
    if (!ctx)return -1;
    memset(ctx, 0, sizeof(VideoSimilarityContext));
    ctx->video_path = strdup(url);
    return (long) ctx;
}


int video_similarity_detection_start(long id, int force_keyframe,long start_time, int frame_count, DisableMediaType disableMediaType,
                                     std::vector<VideoSimilarityModel *> &lists) {
    if (id <= 0)return -1;
    auto *ctx = (VideoSimilarityContext *) id;
    long d_id = initDecoder(ctx->video_path, force_keyframe, start_time, frame_count, disableMediaType);
    ctx->decode_obj_id = d_id;
    if (ctx->decode_obj_id <= 0)return ctx->decode_obj_id;
    int exit = 0, ret = 0;
    av_read_decode_frame(ctx->decode_obj_id);
    auto *dctx = (DecoderContext *) ctx->decode_obj_id;
    while (!exit) {
        AVFrame *video_frame = NULL;
        dctx->video_queue->PopFront(video_frame);
        if (video_frame == NULL) {
            LOGE("read video frame end.");
            break;
        }

        int len = 0;
        const char *image_hash = fingerprintFromFFAVFrame(video_frame, &len);
        auto model = new VideoSimilarityModel();
        model->pts = video_frame->pts;
        model->img_len = len;
        if (len > 0) {
            model->image_hash = static_cast<const char *>(malloc(sizeof(char) * len));
            memcpy((void*)model->image_hash, image_hash, len);
        }
        model->pict_type = video_frame->pict_type;
        lists.push_back(model);
        if (image_hash)
            free((void *) image_hash);
        av_frame_free(&video_frame);
    }
    return 0;
}

int video_similarity_detection_close(long id) {
    if (id <= 0)return -1;
    auto *ctx = (VideoSimilarityContext *) id;

    if (ctx->video_path) {
        free((void *) ctx->video_path);
        ctx->video_path = NULL;
    }
    close_decoder(ctx->decode_obj_id);
    free(ctx);
    ctx = NULL;
    return 0;
}
